<template>
  <div>
    <v-row>
      <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
        <div id="pieChart" class="charts" ref="pieChart"></div>
      </v-col>
    </v-row>
    <v-row>
      <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
        <DefectoPorMillon
          :is-loading="isLoading"
          :global-filters-parent="globalFilters"
        />
      </v-col>
    </v-row>
  </div>
</template>
<style scoped>
.charts {
  height: 200px;
}
</style>
<script>
import htmlToImage from "html-to-image";
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
import am4themes_material from "@amcharts/amcharts4/themes/material";
import axios from "axios";
import DefectoPorMillon from "@/views/secure/sistema-informacion/dashboards/commons/graficos/DefectoPorMillon003.vue";
export default {
  name: "Component-CalificacionTotalDisciplina",
  components: {
    DefectoPorMillon
  },
  props: {
    isLoading: Function,
    methodsSemaforoParent: Object,
    globalFiltersParent: Object
  },
  data() {
    return {
      chart: null,
      methodsSemaforo: null,
      globalFilters: null,
      totalDisciplina: []
    };
  },
  computed: {
    calificacionTotalDisciplina() {
      if (this.totalDisciplina[1]) {
        return this.totalDisciplina[1].calificacion_final;
      } else {
        return 0;
      }
    }
  },
  methods: {
    listenSearchConsulta(globalFilters) {
      this.globalFilters = globalFilters;
      this.getTotalDisciplina();
    },
    listenSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    getTotalDisciplina() {
      this.isLoading(true);
      const self = this;
      const contentFiltros = {
        filtros: this.globalFilters.final_filters
      };
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/calificacion/total/disciplina/nivel",
          contentFiltros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setTotalDisciplina(data);
              }
            } else {
              self.setTotalDisciplina([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoading(false);
        });
    },
    setTotalDisciplina(totalDisciplina) {
      this.totalDisciplina = [];
      let diferencia = {
        calificacion_final: 0,
        color: am4core.color("#FFF")
      };
      if (
        this.methodsSemaforo &&
        this.methodsSemaforo.getRangoByLimit(totalDisciplina.calificacion_final)
      ) {
        let rango = this.methodsSemaforo.getRangoByLimit(
          totalDisciplina.calificacion_final
        );
        
        totalDisciplina.color = am4core.color(rango.detalle);
      } else {
        totalDisciplina.color = am4core.color("grey");
      }
      diferencia.calificacion_final = 100 - totalDisciplina.calificacion_final;
      this.totalDisciplina.push(diferencia);
      this.totalDisciplina.push(totalDisciplina);
      this.drawChart();
    },
    drawChart() {
      if (this.chart) {
        this.chart.dispose();
      }
      am4core.options.autoSetClassName = true;
      const config = {
        data: this.totalDisciplina,
        innerRadius: am4core.percent(60),
        legend: {
          disabled: true,
          width: 300,
          labels: {
            disabled: true
          },
          itemContainers: {
            clickable: false,
            focusable: false
          },
          valueLabels: {
            disabled: true
          },
          properties: {
            contentAlign: "left",
            position: "right",
            alwaysShowTooltip: true
          }
        },
        logo: {
          properties: {
            hidden: true
          }
        },
        series: [
          {
            type: "PieSeries",
            children: [
              {
                type: "Label",
                text: "{values.value.sum}",
                forceCreate: true,
                html:
                  "<div style='text-align: center'><strong>" +
                  this.calificacionTotalDisciplina +
                  "</strong></div>",
                horizontalCenter: "middle",
                verticalCenter: "middle",
                fontSize: 48
              }
            ],
            calculatePercent: true,
            tooltip: {
              disabled: true
            },
            dataFields: {
              value: "calificacion_final",
              category: "id_disciplina"
            },
            labels: {
              disabled: true
            },
            alignLabels: false,
            ticks: {
              disabled: true
            },
            slices: {
              template: {
                propertyFields: {
                  fill: "color"
                }
              },
              stroke: am4core.color("white"),
              strokeWidth: 1,
              strokeOpacity: 1,
              states: {
                hover: {
                  properties: {
                    scale: 1
                  }
                },
                active: {
                  properties: {
                    shiftRadius: 23
                  }
                }
              }
            }
          }
        ]
      };
      let initChart = () => {
        let chart = am4core.createFromConfig(
          config,
          this.$refs.pieChart,
          am4charts.PieChart
        );
        chart.legend.useDefaultMarker = true;
        this.chart = chart;
      };
      initChart();
    }
  },
  mounted() {
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
    this.$root.$on("rangoloaded", this.listenSemaforo);
    this.drawChart();
  },
  created() {
    this.methodsSemaforo = this.methodsSemaforoParent;
    this.globalFilters = this.globalFiltersParent;
    if (this.globalFilters && this.methodsSemaforo) {
      this.getTotalDisciplina();
    }
  },
  beforeDestroy() {
    if (this.chart) {
      this.chart.dispose();
    }
  }
};
</script>
